;set parameters
nx=299
dir='../runenv/'
;dir='../test/'
rmaxi=1500.
;disk rmaxi=220.
d=140.       ;distance in pc 
inclab='_80_'
;set ivoigt=1 if you want to convolve images with PSF.
ivoigt=1
wgaussa = 0.1  ; width of gauss FWHM in arcsec
wvoigta=0.1    ;wing component (zero for none, i.e., gaussian only), 
               ;0.5 gives huge wings.  this adds some to the FWHM too.
ngwidth=6   ; number of gaussian FWHM widths for PSF.  increase if
                                ; wvoigt is big or if result is boxy
                                ; (the box is the size of the PSF)

;other things you might want to vary are min-max plotting
;parameters, below (minj, maxj)

;reset psf fourier transform if rerunning program
psf_ft=0.

;reads in jhkl images.  plots jhk, change to any combination you want.

;read in J,H,K,L-band images
readdat,dir+'eI'+inclab+'J.dat',nx,imj1
readdat,dir+'eI'+inclab+'H.dat',nx,imh1
readdat,dir+'eI'+inclab+'K.dat',nx,imk1
readdat,dir+'eI'+inclab+'L.dat',nx,iml1

if ivoigt eq 1 then begin
;convolve with voigt profile
   pixsize=2.*rmaxi/nx
   wgauss=wgaussa/pixsize*d
   wvoigt=wvoigta
   vwide=ngwidth*wgauss
   if vwide gt nx then vwide=nx
   psf = psf_voigt_2d(vwide,wvoigt,wgauss)
   psf=psf/total(psf)
   imj=convolve(imj1,psf,FT_PSF=psf_FT)
   imh=convolve(imh1,psf,FT_PSF=psf_FT)
   imk=convolve(imk1,psf,FT_PSF=psf_FT)
   iml=convolve(iml1,psf,FT_PSF=psf_FT)

;   convvoigt,wgauss,wvoigt,ngwidth,imj1,imj,nx
;   convvoigt,wgauss,wvoigt,ngwidth,imh1,imh,nx
;   convvoigt,wgauss,wvoigt,ngwidth,imk1,imk,nx
;   convvoigt,wgauss,wvoigt,ngwidth,iml1,iml,nx
endif else begin
   imj=imj1
   imh=imh1
   imk=imk1
   iml=iml1
endelse

; intrinsic colors of source, taking average for TTS
;j0-k0
jk0=1.2
;h0-k0
hk0=0.43
;k0-l0
kl0=0.8

;scale images to k-band
imj=imj*10^(-0.4*jk0)
imh=imh*10^(-0.4*hk0)
iml=iml*10^(0.4*kl0)

sky=1.e-9

imj=alog10(imj>sky)
imh=alog10(imh>sky)
imk=alog10(imk>sky)
iml=alog10(iml>sky)


maxj=max([max(imj),max(imh),max(imk),max(iml)])
minj=min([min(imj),min(imh),min(imk),min(iml)])
print,'maxj,minj',maxj,minj

;note that these are scaled to the K-band stellar flux. i.e,
;-5 is 10^(-5) K stellar flux.
minj=minj+1
maxj=minj+3

imj=bytscl(imj,min=minj,max=maxj)
imh=bytscl(imh,min=minj,max=maxj)
imk=bytscl(imk,min=minj,max=maxj)
iml=bytscl(iml,min=minj,max=maxj)

set_plot,'x'
window,0,xsize=nx,ysize=nx,retain=2
tv,imj,channel=3
tv,imh,channel=2
tv,imk,channel=1
;tv,iml,0,channel=1

image=bytarr(3,nx,nx)
image(2,*,*)=imj
image(1,*,*)=imh
image(0,*,*)=imk

;write_tiff,'colim.tif',image
write_jpeg,'colim.jpg',image,true=1,quality=100
;write_jpeg,fileo,image,true=1

end




