      subroutine gridset(eps)

c  set up grid:  3-D spherical grid with variable spacing in r and 
c  theta (set by exponents, rexp, texp)
c  make a bunch of arrays necessary for find_wall subroutine

c history:
c 00/09/06 (baw): write subroutine
	
      implicit none
      include 'tts.txt'
      include 'out.txt'
      include 'grid.txt'
      include 'opacin.txt'

      real*8 dr,dt,dp,rad,phi,thet,pi,r2p,densd,dense,vol
     $ ,cost,sint,pihalf,eps,tau,rming1,rming2,rming3,tiny
     $     ,rmincgs,taud,taue,rfac,thettop,thetatm,mu,res
     $     ,thetmin,kappa,mu0,taustep,geps,deps
      real xyarr(200,200),x,y,xmax,dx,r
      integer ir,it,ip,nttmp,gflag,n,ix,iy,irbeg,nrwall,ntatm,iinc,flag
     1 ,id,ide,idd

      pi=4.d0*datan(1.d0)
      r2p=2.d0*pi
      pihalf=pi/2.d0
      tiny=1.d-15
      rmincgs=rstar*rsol

c     convert opacity to units of cm^2/gm*rstar(cgs) because distance
c     is in units if 1/rstar, and dtau=kapd*rho*ds
	do id=1,4
        kapd(id)=kapd(id)*rmincgs
        print*,'kapd(id)',kapd(id)
	enddo
	
c     calculate some constants for the TSC envelope density
      call envset

c     make grid include minimum and maximum values.

      print*, ' '
      print*, 'grid setup'

c     rgrid
      gflag=0
      rarr(1)=rmin
c     since there's empty space below rmine and rmind....
      if (rddust.lt.rmine) then
         gflag=1
         rarr(2)=rddust
         rming1=rddust
         rming2=rmine
         irbeg=2
      else if (rddust.gt.rmine) then
         gflag=2
         rarr(2)=rmine
         rming1=rmine
         rming2=rddust
         irbeg=3
      else if (rddust.eq.rmine) then
         gflag=3
         rarr(2)=rmine
         rming1=rmine
         irbeg=2
      endif

      if (massd.eq.0.) then
c     since there's empty space below rmine and rddust....
         dr=(rmax-rming1)/(dfloat(nrg-2))**rexp
         print*,'rexp,dr,rmin',rexp,dr/autors,rmin/autors
         do ir=3,nrg
            rarr(ir)=rming1+dr*(dfloat(ir-2))**rexp
c     print*,'rarr ',ir,rarr(ir)/au
         enddo

      else
         
c     do we even need to do this for scattering code?????
c     only need it for radeq....
c     042402, BAW, try skipping it...
         go to 89
c     finely sample disk to radial optical depth taux (computed
c     in setup_wave.f)
         taustep=1.d0
c         do while (taustep.gt.1.d0.and.taustep.le.1000.d0)
  30     continue
         nrwall=irbeg+int(taux/taustep)+1 !tau=1 steps
		print*,'nrwall',nrwall
	   if (nrwall.gt.nrg) then
			write(*,*) 'too many points in rgrid'
			stop
		endif
c	rdx is radius where tau=taux=20
		print*,'rdx,rddust',rdx,rddust
		rfac=(dlog(rdx)/dlog(rddust))**(1.d0/float(nrwall-irbeg))
		print*,'rfac',rfac
		rarr(irbeg)=rddust
		do ir=irbeg,nrwall-1
			rarr(ir+1)=rarr(ir)**rfac
			deps=(rarr(ir+1)-rarr(ir))*eps
			print*,'deps',deps
			if (deps.lt.5.e-15) then
				print*,'rarr spacing too small, resetting taustep'
				taustep=taustep*2.d0
				print*,'new taustep',taustep
               go to 30
			endif
		enddo
         if (taustep.gt.1000.d0) then
            nrwall=irbeg
            rarr(nrwall)=rddust
            print*,'disk too thick to finely sample in tau'
         endif
         print*,'irbeg,nrwall',irbeg,nrwall
c     stop
 89      nrwall=irbeg
         rarr(nrwall)=rddust

         rming1=rarr(nrwall)
         dr=(rmax-rming1)/(dfloat(nrg-nrwall))**rexp
         print*,'rexp,dr,rmin',rexp,dr/autors,rming1
         do ir=nrwall+1,nrg
            rarr(ir)=rming1+dr*(dfloat(ir-nrwall))**rexp
         enddo

      endif

c     set rmine to a grid location
      if (gflag.eq.1) then
         call locate(rarr,nrg,rmine,ir)
         rarr(ir+1)=rmine
         print*,'rmine',rmine
      endif

c     r-squared array
      do ir=1,nrg
         r2arr(ir)=rarr(ir)**2
c     print first few points of rarr
         if (ir.lt.10) then
            print*,'rarr/rmin,ir ',rarr(ir)/rmin,ir
         endif
      enddo

      open(unit=15,file='rarr.dat',status='unknown')
      write(15,*) nrg,' = number of grid points in r'
      write(15,*) '      index     r/rstar         r(au)'
      do ir=1,nrg
         write(15,*) ir,sngl(rarr(ir)),sngl(rarr(ir)/autors)
      enddo
      close(15)

      print*,'rarr(nrg),r2arr(nrg)',rarr(nrg),r2arr(nrg)

      if (ntg.gt.1) then
c     set up a tmp array going from 0 - 90 from equ. to pole
c     make theta=0 bin 5 degrees wide (otherwise, too much noise,
c     nothing happens there anyway)
         thettop=5.*pi/180.
         if (massd.eq.0.d0) then

            ntatm=1
            thetatm=0.d0
            tmptharr(1)=0.d0
            nttmp=(ntg+1)/2

         else
c     make spacing fine for, say first 10 scale heights
            mu=10.d0*z1*rddust**b/rddust
            if (mu.gt.0.5) mu=0.5
            thetatm=asin(mu)
c     test
            print*,'thetatm',thetatm*180./pi
            nttmp=(ntg+1)/2

c     *********************
c     change this for disk or envelope runs
c     for envelope with 1 degree resolution in polar region
c     except for first bin (theta=5).
            res=1.
c     for disk with nothing in the polar region
c     res = size of angle bin in poles, approximately 
c     res=10.
c     *********************

            ntatm=nttmp-(pihalf-thetatm-thettop)*90./pihalf/res/2.
            print*,'ntatm',ntatm

            mu0=z1*rddust**b/rddust
            print*,'thet of 1 scale height at disk',
     1           sngl(asin(mu0)*180./pi),' degrees'
            thetmin=min(0.1*asin(mu0),thetatm/float(ntatm))

c     jon's log spacing.
c            tmptharr(1)=0.d0
c            do it=2,ntatm
c               tmptharr(it)=thetmin *
c     1              (thetatm/thetmin)**((it-2.d0)/(ntatm-2.d0))
cc     print*,'tmptharr ',tmptharr(it)*180.d0/pi
c            enddo

c     barb's equal spacing
            do it=2,ntatm
               tmptharr(it)=float(it-1)*thetatm/float(ntatm-1) 
            enddo
            
         endif
         do it=ntatm+1,nttmp-1
            tmptharr(it)=thetatm+
     1           (it-ntatm)*(pihalf-thetatm-thettop)/(nttmp-ntatm)
c     print*,'tmptharr(it)',tmptharr(it)
         end do
         tmptharr(nttmp)=pihalf
         
         thetarr(nttmp)=pihalf
         do it=2,nttmp-1
            thetarr(nttmp+1-it)=pihalf-tmptharr(it)
            thetarr(nttmp-1+it)=pihalf+tmptharr(it)
         enddo
         thetarr(1)=0.d0

         thetarr(ntg)=pi
         
c     newdisktherm for that
         geps=1.d-8
         do it=1,ntg
            if (it.eq.1) then
               thetarr(it)=0.d0
               costarr(it)=1.d0
               sintarr(it)=0.d0
               tan2arr(it)=0.d0
            else if (it.eq.ntg) then
               thetarr(it)=pi
               costarr(it)=-1.d0
               sintarr(it)=0.d0
               tan2arr(it)=0.d0
            else if (it.eq.nttmp) then
               thetarr(it)=pihalf
               costarr(it)=0.d0
               sintarr(it)=1.d0
               tan2arr(it)=-1.d0
            else
               costarr(it)=cos(thetarr(it))
               sintarr(it)=sin(thetarr(it))
               tan2arr(it)=tan(thetarr(it))**2
            endif
c            if(thetarr(it).gt.(pihalf-geps).and.thetarr(it).lt.
c     1           (pihalf+geps)) 
c     1           then
c               tan2arr(it)=-1.d0
c            else
c               tan2arr(it)=tan(thetarr(it))**2
c            endif
c            print*,'thetarr,costarr,tan2arr '
c            print*,'thetarr',thetarr(it)*180.d0/pi
         enddo
      else
         thetarr(1)=0.d0
         costarr(1)=1.d0
         sintarr(1)=0.d0
         tan2arr(1)=0.d0
      endif

      open(unit=15,file='tharr.dat',status='unknown')
      write(15,*) ntg,' = number of grid points in theta'
      write(15,*) 
     1     'index  thet(rad)  thet(deg)    cost     tan**2(thet)'
      do it=1,ntg
        write(15,*) it,sngl(thetarr(it)),sngl(thetarr(it)*180.d0/pi),
     1        sngl(costarr(it)),sngl(tan2arr(it))
      enddo
      close(15)

      if (npg.gt.1) then
         dp=r2p/dfloat(npg-1)
         do ip=1,npg
            phiarr(ip)=dp*(dfloat(ip-1))
            aarr(ip)=dsin(phiarr(ip))
            barr(ip)=-dcos(phiarr(ip))
c     print*,'phiarr, aarr, barr ',phiarr(ip),aarr(ip),barr(ip)
c     carr(ip)=
c     darr(ip)=
         enddo
      else
         dp=r2p
         ip=1
         phiarr(ip)=0.d0
         aarr(ip)=dsin(phiarr(ip))
         barr(ip)=-dcos(phiarr(ip))
      endif

      open(unit=15,file='phiarr.dat',status='unknown')
      write(15,*) npg
      do ip=1,npg
         write(15,*) phiarr(ip)*180.d0/pi
      enddo
      close(15)

c     calculate density in grid
      massenv=0.d0
      massdisk=0.d0
      do ir=1,nrg-1
         rad=0.5d0*(rarr(ir)+rarr(ir+1))
         dr=rarr(ir+1)-rarr(ir)
         if (ntg.gt.1) then     !2- or 3-D atmosphere
            do it=1,ntg-1
               thet=0.5d0*(thetarr(it)+thetarr(it+1))
               cost=cos(thet)
               sint=sin(thet)
               dt=thetarr(it+1)-thetarr(it)
               if (npg.gt.1) then
                  do ip=1,npg-1   !3-D atmosphere
                     phi=0.5d0*(phiarr(ip)+phiarr(ip+1))
                     dp=phiarr(ip+1)-phiarr(ip)
                     call densenv(rad,thet,cost,sint,pi,pihalf,phi
     1                    ,dense,ide)
                     vol=rad**2*sint*dt*dp*dr*rmincgs**3
                     massenv=massenv+dense*vol
                     call densdisk(rad,sint,cost,phi,densd,idd)
                     massdisk=massdisk+densd*vol
                     densarr(ir,it,ip)=dense+densd
                     massarr(ir,it,ip)=(dense+densd)*vol
c                     if (idd.eq.0) then
c                        dustarr(ir,it,ip)=ide
c                     else
                        if (dense.gt.densd) then
                           dustarr(ir,it,ip)=ide
                        else
                           dustarr(ir,it,ip)=idd
                        endif
c                     endif
                  end do
               else           !2-D atmosphere
                  ip=1       
                  phi=0.d0
                  dp=r2p
                  call densenv(rad,thet,cost,sint,pi,pihalf,phi
     1                 ,dense,ide)
                  vol=rad**2*sint*dt*dp*dr*rmincgs**3
                  massenv=massenv+dense*vol
                  call densdisk(rad,sint,cost,phi,densd,idd)
                  massdisk=massdisk+densd*vol
                  densarr(ir,it,ip)=dense+densd
                  massarr(ir,it,ip)=(dense+densd)*vol
c                  if (idd.eq.0) then
c                     dustarr(ir,it,ip)=ide
c                  else
                     if (dense.gt.densd) then
                        dustarr(ir,it,ip)=ide
                     else
                        dustarr(ir,it,ip)=idd
                     endif
c                  endif
                endif
            enddo
         else              !1-D atmosphere
            phi=0.d0
            ip=1
            it=1
            thet=0.d0
            cost=1.d0
            sint=0.d0
            call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense,ide)
            vol=rad**2*dr*2.d0*r2p*rmincgs**3
            massenv=massenv+dense*vol
            call densdisk(rad,sint,cost,phi,densd,idd)
            massdisk=massdisk+densd*vol
            densarr(ir,it,ip)=dense+densd
            massarr(ir,it,ip)=(dense+densd)*vol
c            if (idd.eq.0) then
c               dustarr(ir,it,ip)=ide
c            else
              if (dense.gt.densd) then
                 dustarr(ir,it,ip)=ide
              else
                 dustarr(ir,it,ip)=idd
              endif
c            endif
c     print*,'densarr',densarr(ir,it,ip)
         endif
      end do
      massenv=massenv/1.989d33
      massdisk=massdisk/1.989d33
c     important note:  densarr(ir,it,ip) is the density halfway between
c     ir and ir+1, it and it+1, ip and ip+1; it is NOT the density at
c     ir,it,ip.

      print*, 'massenv (in solar units) ',massenv
      print*, 'massdisk from grid, compared to input ',massdisk,
     $     massd
      print*, ' '

c     write out rarr,thetarr,densarr at phi=0 so you can read them into
c     IDL.

c	check dustarr
	do ir=1,nrg
	do it=1,ntg
	do ip=1,npg
           if (rarr(ir).lt.rmine.and.rarr(ir).lt.rmind) 
     $          dustarr(ir,it,ip)=4
	   if (dustarr(ir,it,ip).eq.0) then
	     if (ir.ne.nrg.and.it.ne.ntg) then
	        print*,'oops, dustarr,r,th,phi',
     $	     rarr(ir),thetarr(it),phiarr(ip)	
            endif
            dustarr(ir,it,ip)=4    !outflow dust    
	   endif
	enddo
	enddo
	enddo


c     integrate optical depth along the theta angles
c     at phi=0.
      open(unit=15,file='tau.dat',status='unknown')
      write(15,*) 
     1 '    theta          tau_env        tau_disk       tau_tot'
      do it=1,ntg
         tau=0.d0
         taud=0.d0
         taue=0.d0
         if (ntg.eq.1) then
            thet=60.d0*pi/180.d0
         else
            thet=thetarr(it)
         endif
         if (ntg.gt.1.and.it.eq.(ntg/2)+1) then
c     TSC blows up at thet=90
            print*,'thet',thet*180./pi
            thet=89.999d0*pi/180.d0
            flag=1
         else
            flag=0
         endif
         cost=cos(thet)
         sint=sin(thet)
         phi=0.d0
c         print*,'kapd',kapd
         do ir=1,nrg-1
            dr=rarr(ir+1)-rarr(ir)
            rad=0.5d0*(rarr(ir)+rarr(ir+1))
            call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense,ide)
            call densdisk(rad,sint,cost,phi,densd,idd)
            id=dustarr(ir,it,1)
            taud=taud+kapd(id)*(densd)*dr
            taue=taue+kapd(id)*(dense)*dr
c            if (flag.eq.1) then
c               print*,'r,dtaud in equator',rarr(ir),
c     1              kapd*(densd)*dr
c            endif
         end do
         write(15,*) sngl(thet*180.d0/pi),sngl(taue)
     1        ,sngl(taud),sngl(taue+taud)
c     print this out to see dtaud---log(R) spacing works!
      end do
      close(15)

c     calculate tau along ethet,ephi directions (peeled image)
	taud=0.
	taue=0.
      open(unit=15,file='tau_e.dat',status='unknown')
      write(15,*) 
     1 '    theta           tau_env         tau_disk        tau_tot'
      thet=thete
      cost=cos(thet)
      sint=sin(thet)
      call locate(thetarr,ntg,thet,it)
      phi=0.d0
      do ir=1,nrg-1
         dr=rarr(ir+1)-rarr(ir)
         rad=0.5d0*(rarr(ir)+rarr(ir+1))
         id=dustarr(ir,it,1)
         call densenv(rad,thet,cost,sint,pi,pihalf,phi,dense,ide)
         call densdisk(rad,sint,cost,phi,densd,idd)
         taud=taud+kapd(id)*(densd)*dr
         taue=taue+kapd(id)*(dense)*dr
      end do
      write(15,*) sngl(thet*180.d0/pi),sngl(taue)
     1     ,sngl(taud),sngl((taue+taud))
      close(15)

c     write out density array to read in IDL
c     make the cartesian grid here (fortran is faster than IDL)
c     this makes a grid in the x-z plane
c      n=200
c      xmax=sngl(xymaxdens)
c      print*,'xmax',xmax
c      dx=xmax/float(n)
c      do ix=1,n
c         x=dx*(float(ix)-0.5)
c      do iy=1,n
c         y=dx*(float(iy)-0.5)
c         if (iy.eq.1.and.ix.eq.1) print*,'x0,y0',x,y
c         r=sqrt(x**2+y**2)
c         thet=atan2(y,x)
c         call locate(rarr,nrg,dble(r),ir)
c         if (ntg.gt.1) then
c            call locate(thetarr,ntg,(thet),it)
c         else
c            it=1
c         endif
c         xyarr(ix,iy)=sngl(densarr(ir,it,1))
c      end do
c      end do
c      open(unit=15,file='densxz.dat',status='unknown')
c      do ix=1,n
c         write(15,*) (xyarr(ix,iy),iy=1,n)
c      enddo
c      close(15)

c     write out array in x-y plane at z=.5*rmax to see phi dependence
c      thet=pi/2.d0
c      if (ntg.gt.1) then
c         call locate(thetarr,ntg,(thet),it)
c      else
c         it=1
c      endif
c      do ix=1,n
c         x=dx*(float(ix)-0.5)
c      do iy=1,n
c         y=dx*(float(iy)-0.5)
c         if (iy.eq.1.and.ix.eq.1) print*,'x0,y0',x,y
c         r=sqrt(x**2+y**2)
c         phi=atan2(y,x)
c         call locate(rarr,nrg,dble(r),ir)
c         if (npg.gt.1) then
c            call locate(phiarr,npg,(phi),ip)
c         else
c            ip=1
c         endif
c         xyarr(ix,iy)=sngl(densarr(ir,it,ip))
c      end do
c      end do
c      open(unit=15,file='densxy.dat',status='unknown')
c      do ix=1,n
c         write(15,*) (xyarr(ix,iy),iy=1,n)
c      enddo
c      close(15)
      
c     write out densarr
      open(unit=15,file='darr.unf',status='unknown',form='unformatted')
      write(15) nrg,ntg,npg
      write(15) (rarr(ir)/autors,ir=1,nrg)
      write(15) (thetarr(it),it=1,ntg)
      write(15) (phiarr(ip),ip=1,npg)
      write(15) (((densarr(ir,it,ip),ir=1,nrg),it=1,ntg)
     1     ,ip=1,npg)
      close(15)
      
c	write out dustarr
      open(unit=15,file='dust.unf',status='unknown',form='unformatted')
      write(15) nrg,ntg,npg
      write(15) (rarr(ir)/autors,ir=1,nrg)
      write(15) (thetarr(it),it=1,ntg)
      write(15) (phiarr(ip),ip=1,npg)
      write(15) (((dustarr(ir,it,ip),ir=1,nrg),it=1,ntg)
     1     ,ip=1,npg)
      close(15)

      end
